﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
    public class LessVisibleDamageSyringe : SyringeBehaviour
    {
        public static void Load()
        {
            ModAPI.RegisterLiquid(LessVisibleDamageSyringeSerum.ID, new LessVisibleDamageSyringeSerum());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

                    NameOverride = "​<b></b>" + "Less Visible Damage Syringe",
                    DescriptionOverride = "Syringe that lessens the damage taken, but only visually.",
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/invc.png"),

                    CategoryOverride = ModAPI.FindCategory("Polars Bear"),
                    AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<LessVisibleDamageSyringe>(); }
                }
            );
        }
        public override string GetLiquidID() => LessVisibleDamageSyringeSerum.ID;
        public class LessVisibleDamageSyringeSerum : Liquid
        {
            public const string ID = "​<b></b>" + "";
            public LessVisibleDamageSyringeSerum()
            {
                Color = new UnityEngine.Color(1.00000f, 1.00000f, 1.0000f);
            }
            public override void OnEnterLimb(LimbBehaviour limb)
            {
                for (int i = UnityEngine.Random.Range(0, Mathf.RoundToInt(limb.SkinMaterialHandler.damagePoints.Length / 2)); i < Mathf.RoundToInt(limb.SkinMaterialHandler.damagePoints.Length / 2); i++)
                {
                    Vector4[] damagePoints = limb.SkinMaterialHandler.damagePoints;
                    int num = i;
                    damagePoints[num].z = 100f;
                }

            }
            public override void OnExitContainer(BloodContainer container) { }
            public override void OnUpdate(BloodContainer container) { }
            public override void OnEnterContainer(BloodContainer container) { }
        }

    }
}

//Author: Polars Bear
