﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
	public class ZombieCureSyringe : SyringeBehaviour
	{
		public const string name = "​<b></b>" + "Zombie Cure Syringe";
		public static void Load()
        {
			ModAPI.RegisterLiquid(ZombieCureSyringe.ZombieCure.ID, new ZombieCureSyringe.ZombieCure());
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

					NameOverride = name,
					DescriptionOverride = "Syringe that reverts zombies back to their human form.",

					CategoryOverride = ModAPI.FindCategory("Polars Bear"),
					AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<ZombieCureSyringe>(); }
				}
			);
		}
		public override string GetLiquidID() => ZombieCure.ID;
		public class ZombieCure : Liquid
		{
			public const string ID = "​<b></b>" + "ZOMBIE CURE";
			public ZombieCure()
			{
				Color = new UnityEngine.Color(0.11765f, 0.00000f, 0.29020f);
			}
			public override void OnEnterLimb(LimbBehaviour limby)
			{
				if (limby.SpeciesIdentity == "Android")
				{
					return;
				}
				if (!limby.IsZombie) { return; }
				CirculationBehaviour circy = limby.CirculationBehaviour;
				circy.RemoveLiquid(this, circy.GetAmount(this));
				if (limby.SpeciesIdentity == "Android")
				{
					return;
				}
				Liquid zl = Liquid.GetLiquid("REANIMATION AGENT");
				foreach (LimbBehaviour limb in limby.Person.Limbs)
				{
					CirculationBehaviour circ = limb.CirculationBehaviour;
					if (limb.IsZombie)
					{

						limb.IsZombie = false;
						limb.Health = limb.InitialHealth;
						limb.Numbness = 0f;

						circ.BloodFlow = 1f;
						circ.HealBleeding();
						circ.BleedingRate = 0f;
						circ.IsPump = circ.WasInitiallyPumping;
						if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
						{
							limb.Person.Consciousness = 1f;
							limb.Person.ShockLevel = 0f;
							limb.Person.PainLevel = 0f;
							limb.Person.OxygenLevel = 1f;
							limb.Person.AdrenalineLevel = 1f;
						}
						if (limb.SkinMaterialHandler.RottenProgress > 0f)
						{
							circ.StartCoroutine(this.HealRotten(limb));
						}
					}

					if (circ.GetAmount(zl) > 0f)
					{
						typeof(CirculationBehaviour).GetMethod("DiffuseStep", BindingFlags.NonPublic | BindingFlags.Instance).Invoke(circ, null);
						circ.RemoveLiquid(zl, circ.GetAmount(zl));
					}
					float amount = circ.GetAmount(limb.GetOriginalBloodType());
					if (amount < 0.1f)
					{
						circ.AddLiquid(limb.GetOriginalBloodType(), 1f - amount);
					}

				}

			}
			public override void OnExitContainer(BloodContainer container) { }
			public override void OnUpdate(BloodContainer container) { }
			public override void OnEnterContainer(BloodContainer container) { }
			private IEnumerator HealRotten(LimbBehaviour limb)
			{
				while (limb.SkinMaterialHandler.RottenProgress > 0f)
				{
					limb.SkinMaterialHandler.RottenProgress = Math.Max(limb.SkinMaterialHandler.RottenProgress - 0.1f, 0f);
					yield return new WaitForEndOfFrame();
				}

			}

		}
	}
}

//Template by Polars Bear
