﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
	public class CrappyInvincibilitySyringe : SyringeBehaviour
	{
		public const string name = "​<b></b>" + "Rapid Regeneration Syringe";
		public static void Load()
		{

			ModAPI.RegisterLiquid(CrappyInvincibilitySerum.ID, new CrappyInvincibilitySerum());

			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

					NameOverride = name,
					DescriptionOverride = "Syringe that greatly increases the regenerative capabilities of the user.",

					CategoryOverride = ModAPI.FindCategory("Polars Bear"),
					AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<CrappyInvincibilitySyringe>(); }
				}
			);
			Mod.nailgun.SyringeNail(name, typeof(CrappyInvincibilitySyringe));
		}
		public override string GetLiquidID() => CrappyInvincibilitySerum.ID;
		public class CrappyInvincibilitySerum : Liquid
		{
			public const string ID = "​<b></b>" + "RAPID REGENERATION SERUM";
			public CrappyInvincibilitySerum()
			{
				Color = new UnityEngine.Color(0f, 1f, 1f);
			}
			public override void OnEnterLimb(LimbBehaviour limb)
			{
				if (limb.SpeciesIdentity == "Android")
				{
					return;
				}
				limb.CirculationBehaviour.StartCoroutine(this.RapidRegenHealingPB(limb));
			}
			public override void OnExitContainer(BloodContainer container)
			{
				if (container.GetComponent<LimbBehaviour>().SpeciesIdentity == "Android")
				{
					return;
				}
				container.StopCoroutine("RapidRegenHealingPB");
			}
			public override void OnUpdate(BloodContainer container) { }
			public override void OnEnterContainer(BloodContainer container) { }
			static float statichealmult = 0.1f;
			private IEnumerator RapidRegenHealingPB(LimbBehaviour limb)
			{
				
				float tick = 0f;
				while (limb.NodeBehaviour.IsConnectedToRoot && limb.Person.IsAlive())
				{

					tick += Time.deltaTime;
					float healmult = statichealmult * limb.CirculationBehaviour.GetAmount(this);
					if (tick > 1f/healmult)
					{
						limb.CirculationBehaviour.HealBleeding();
						limb.HealBone(); limb.LungsPunctured = false; tick = 0f;
						limb.CirculationBehaviour.IsPump = limb.CirculationBehaviour.WasInitiallyPumping;
					}

					limb.Health = Math.Min(limb.InitialHealth, limb.Health + 2.5f*healmult*Time.deltaTime);
					limb.Numbness = Math.Max(0f, limb.Numbness - .1f*healmult*Time.deltaTime);
					
					limb.CirculationBehaviour.BloodFlow = Math.Min(1f, limb.CirculationBehaviour.BloodFlow + 0.1f*healmult*Time.deltaTime);
					limb.CirculationBehaviour.AddLiquid(limb.GetOriginalBloodType(), Math.Max(Mathf.Min(0.1f*healmult*Time.deltaTime, 1f - limb.CirculationBehaviour.GetAmount(limb.GetOriginalBloodType())), 0f));
					limb.BruiseCount = (ushort)Math.Max(0, limb.BruiseCount - 1);
					limb.CirculationBehaviour.GunshotWoundCount = (ushort)Math.Max(0, limb.CirculationBehaviour.GunshotWoundCount - 1);
					limb.CirculationBehaviour.StabWoundCount = (ushort)Math.Max(0, limb.CirculationBehaviour.StabWoundCount - 1);
					if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
					{
						limb.Person.Consciousness = Math.Min(1f, limb.Person.Consciousness + 0.1f * healmult * Time.deltaTime);
						limb.Person.ShockLevel = Math.Max(0f, limb.Person.ShockLevel - 0.1f * healmult * Time.deltaTime);
						limb.Person.PainLevel = Math.Max(0f, limb.Person.PainLevel - 0.1f * healmult * Time.deltaTime);
						limb.Person.OxygenLevel = Math.Min(1f, limb.Person.OxygenLevel + 0.1f * healmult * Time.deltaTime); ;
						limb.Person.AdrenalineLevel = Math.Min(1f, limb.Person.AdrenalineLevel + 0.1f * healmult * Time.deltaTime); ;
					}
					if (limb.PhysicalBehaviour.BurnProgress > 0)
					{
						limb.PhysicalBehaviour.BurnProgress = Math.Max(0f, limb.PhysicalBehaviour.BurnProgress - 1f * healmult * Time.deltaTime);
					}
					if (limb.SkinMaterialHandler.AcidProgress > 0)
					{
						limb.SkinMaterialHandler.AcidProgress = limb.PhysicalBehaviour.BurnProgress = Math.Max(0f, limb.SkinMaterialHandler.AcidProgress - 1f * healmult * Time.deltaTime);
					}
					if (limb.SkinMaterialHandler.RottenProgress > 0)
					{
						limb.SkinMaterialHandler.RottenProgress = limb.PhysicalBehaviour.BurnProgress = Math.Max(0f, limb.SkinMaterialHandler.RottenProgress - 1f * healmult * Time.deltaTime);
					}
					for (int i = 0; i < limb.SkinMaterialHandler.bulletHolePoints.Length; i++)
					{
						limb.SkinMaterialHandler.bulletHolePoints[i].z = Mathf.Max(limb.SkinMaterialHandler.bulletHolePoints[i].z, 0.05f);
						Vector4[] bulletHolePoints = limb.SkinMaterialHandler.bulletHolePoints;
						int num = i;
						bulletHolePoints[num].z = bulletHolePoints[num].z + Time.deltaTime * .05f;
					}
					for (int i = 0; i < limb.SkinMaterialHandler.damagePoints.Length; i++)
					{
						Vector4[] damagePoints = limb.SkinMaterialHandler.damagePoints;
						int num = i;
						damagePoints[num].z = damagePoints[num].z + Time.deltaTime * .05f;
					}
					limb.SkinMaterialHandler.Sync();
					yield return new WaitForEndOfFrame();
				}
			}
		}
	}
}

//Template by Polars Bear
