﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
    public class FireproofSyringe : SyringeBehaviour
    {
        public const string name = "​<b></b>" + "Fireproof Syringe";
        public static void Load()
        {
            ModAPI.RegisterLiquid(FireproofSyringeSerum.ID, new FireproofSyringeSerum());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

                    NameOverride = name,
                    DescriptionOverride = "Syringe that makes the user immune to burning.",

                    CategoryOverride = ModAPI.FindCategory("Polars Bear"),
                    AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<FireproofSyringe>(); }
                }
            );
            Mod.nailgun.SyringeNail(name, typeof(FireproofSyringe));
        }
        public override string GetLiquidID() => FireproofSyringeSerum.ID;
        public class FireproofSyringeSerum : Liquid
        {
            public const string ID = "​<b></b>" + "FIREPROOF SERUM";
            public FireproofSyringeSerum()
            {
                Color = new UnityEngine.Color(0.64706f, 0.39608f, 0.31373f);
            }
            public override void OnEnterLimb(LimbBehaviour limb)
            {
                PhysicalBehaviour phys = limb.PhysicalBehaviour;
                phys.Properties = Instantiate(phys.Properties);
                phys.Properties.Flammability = 0f;
                phys.Properties.Burnrate = 0f;
                limb.CirculationBehaviour.StartCoroutine(this.ExtinguishLoopPB(phys));
            }
            public override void OnExitContainer(BloodContainer container) 
            {
                container.StopCoroutine("ExtinguishLoopPB");
            }
            public override void OnUpdate(BloodContainer container) { }
            public override void OnEnterContainer(BloodContainer container) { }


            private IEnumerator ExtinguishLoopPB(PhysicalBehaviour phys)
            {
                while (true)
                {
                    if (phys.OnFire)
                    {
                        phys.Extinguish();
                        phys.BurnIntensity = 0f;
                    }
                    yield return new WaitForEndOfFrame();
                }
            }
        }
    }
}

//Author: Polars Bear
