﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
	public class InvincibilitySyringe : SyringeBehaviour
	{
		public const string name = "​<b></b>" /*adding some simple markup to make the ID unique and stay at the top*/ + "Invincibility Syringe";
		public static void Load()
		{
			ModAPI.RegisterLiquid(InvincibilitySyringe.InvincibilitySerum.ID, new InvincibilitySyringe.InvincibilitySerum());
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

					NameOverride = name,
					DescriptionOverride = "Syringe that makes the user immortal.",

					CategoryOverride = ModAPI.FindCategory("Polars Bear"),
					AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<InvincibilitySyringe>(); }
				}
			);
			Mod.nailgun.SyringeNail(name, typeof(InvincibilitySyringe));
		}
		public override string GetLiquidID() => InvincibilitySerum.ID;

		public class InvincibilitySerum : Liquid
		{
			public const string ID = "<b></b>" + "INVINCIBILITY SERUM";
			public InvincibilitySerum()
			{
				Color = new UnityEngine.Color(0.61f, 0.61f, 0.61f);
			}
			public override void OnEnterLimb(LimbBehaviour limb)
			{
				if (limb.SpeciesIdentity == "Android") { return; }

				//limb.ImmuneToDamage = true;

				//Ultra strength part
				limb.BreakingThreshold += 100000f;
				//Life part
				limb.CirculationBehaviour.StartCoroutine(this.InvincibilityPB(limb));

			}

			public override void OnUpdate(BloodContainer container) { }
			public override void OnEnterContainer(BloodContainer container) { }
			public override void OnExitContainer(BloodContainer container)
			{
				container.StopCoroutine("InvincibilityPB");
			}
			private IEnumerator InvincibilityPB(LimbBehaviour limb)
			{
				while (true)
				{

					if (limb.Health != limb.InitialHealth)
					{
						limb.LungsPunctured = false;
						limb.HealBone();
						limb.Health = limb.InitialHealth;
						limb.Numbness = 0f;
						limb.CirculationBehaviour.HealBleeding();
						limb.CirculationBehaviour.IsPump = limb.CirculationBehaviour.WasInitiallyPumping;
						limb.CirculationBehaviour.BloodFlow = 1f;
						limb.CirculationBehaviour.AddLiquid(limb.GetOriginalBloodType(), Mathf.Max(0f, 1f - limb.CirculationBehaviour.GetAmount(limb.GetOriginalBloodType())));
						limb.BruiseCount = 0;
						limb.CirculationBehaviour.GunshotWoundCount = 0;
						limb.CirculationBehaviour.StabWoundCount = 0;
						if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
						{
							limb.Person.Consciousness = 1f;
							limb.Person.ShockLevel = 0f;
							limb.Person.PainLevel = 0f;
							limb.Person.OxygenLevel = 1f;
							limb.Person.AdrenalineLevel = 1f;
						}
					}
					if (limb.PhysicalBehaviour.BurnProgress > 0)
					{
						limb.PhysicalBehaviour.BurnProgress = 0f;
					}
					if (limb.SkinMaterialHandler.AcidProgress > 0)
					{
						limb.SkinMaterialHandler.AcidProgress = 0f;
					}
					if (limb.SkinMaterialHandler.RottenProgress > 0)
					{
						limb.SkinMaterialHandler.RottenProgress = 0f;
					}
					for (int i = 0; i < limb.SkinMaterialHandler.bulletHolePoints.Length; i++)
					{
						limb.SkinMaterialHandler.bulletHolePoints[i].z = Mathf.Max(limb.SkinMaterialHandler.bulletHolePoints[i].z, 0.05f);
						Vector4[] bulletHolePoints = limb.SkinMaterialHandler.bulletHolePoints;
						int num = i;
						bulletHolePoints[num].z = bulletHolePoints[num].z + Time.deltaTime * 10f;
					}

					for (int i = 0; i < limb.SkinMaterialHandler.damagePoints.Length; i++)
					{
						Vector4[] damagePoints = limb.SkinMaterialHandler.damagePoints;
						int num = i;
						damagePoints[num].z = damagePoints[num].z + Time.deltaTime * 10f;
					}

					limb.SkinMaterialHandler.Sync();
					yield return new WaitForEndOfFrame();
				}

			}
		}
	}
}

//Template by Polars Bear
