﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
    public class IronSkinSyringe : SyringeBehaviour
    {
        public const string name = "​<b></b>" + "Iron Skin Syringe";
        public static void Load()
        {
            ModAPI.RegisterLiquid(IronSkinSyringeSerum.ID, new IronSkinSyringeSerum());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

                    NameOverride = name,
                    DescriptionOverride = "Syringe that makes the user unable to be stabbed.",

                    CategoryOverride = ModAPI.FindCategory("Polars Bear"),
                    AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<IronSkinSyringe>(); }
                }
            );
            Mod.nailgun.SyringeNail(name, typeof(IronSkinSyringe));
        }
        public override string GetLiquidID() => IronSkinSyringeSerum.ID;
        public class IronSkinSyringeSerum : Liquid
        {
            public const string ID = "​<b></b>" + "IRON";
            public IronSkinSyringeSerum()
            {
                Color = new UnityEngine.Color(0.60000f, 0.60000f, 1.00000f);
            }
            public override void OnEnterLimb(LimbBehaviour limb)
            {
                PhysicalBehaviour phys = limb.PhysicalBehaviour;
                phys.Properties = Instantiate(phys.Properties);
                phys.Properties.Softness = 0f;
                phys.Properties.Brittleness = 0f;
                phys.Properties.ImpactIntensityMutliplier = 0f;
            }
            public override void OnExitContainer(BloodContainer container) { }
            public override void OnUpdate(BloodContainer container) { }
            public override void OnEnterContainer(BloodContainer container) { }
        }
    }
}

//Author: Polars Bear
