﻿using UnityEngine;
using System;
using System.Collections;
using System.Reflection;

namespace Mod
{
	public class NoPainSyringe : SyringeBehaviour
	{
		public const string name = "​<b></b>" + "Strong Constitution Syringe";
		public static void Load()
        {
			ModAPI.RegisterLiquid(NoPainSyringe.NoPainSerum.ID, new NoPainSyringe.NoPainSerum());
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

					NameOverride = name,
					DescriptionOverride = "Syringe that makes the user no longer feel pain or shock.",


					CategoryOverride = ModAPI.FindCategory("Polars Bear"),
					AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<NoPainSyringe>(); }
				}
			);
			Mod.nailgun.SyringeNail(name, typeof(NoPainSyringe));
		}
		public override string GetLiquidID() => NoPainSerum.ID;
		public class NoPainSerum : Liquid
		{
			public const string ID = "​<b></b>" + "PAIN NULLIFICATION SERUM";
			public NoPainSerum()
			{
				Color = new UnityEngine.Color(0.80000f, 0.20000f, 0.00000f);
			}
			public override void OnEnterLimb(LimbBehaviour limb)
			{
				if (limb.SpeciesIdentity == "Android")
				{
					return;
				}
				limb.Person.gameObject.GetOrAddComponent<PainNullifier>();
			}
			public override void OnExitContainer(BloodContainer container) { }
			public override void OnUpdate(BloodContainer container) { }
			public override void OnEnterContainer(BloodContainer container) { }
			public class PainNullifier : MonoBehaviour
			{
				private PersonBehaviour person;
				void Awake()
				{
					person = GetComponent<PersonBehaviour>();
				}

				void OnGUI()
				{
					if (person.PainLevel > 0f)
					{
						person.PainLevel = 0f;
					}
					if (person.ShockLevel > 0f)
					{
						person.ShockLevel = 0f;
					}
				}
			}
		}
	}
}

//Template by Polars Bear
