﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
    public class PreservationSyringe : SyringeBehaviour
    {
        public const string name = "​<b></b>" + "Preservation Syringe";
        public static void Load()
        {
            ModAPI.RegisterLiquid(PreservationSyringeSerum.ID, new PreservationSyringeSerum());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

                    NameOverride = name,
                    DescriptionOverride = "Syringe that reverts rot and preserves corpses.",

                    CategoryOverride = ModAPI.FindCategory("Polars Bear"),
                    AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<PreservationSyringe>(); }
                }
            );
            Mod.nailgun.SyringeNail(name, typeof(PreservationSyringe));
        }
        public override string GetLiquidID() => PreservationSyringeSerum.ID;
        public class PreservationSyringeSerum : Liquid
        {
            public const string ID = "​<b></b>" + "PRESERVATION FLUID";
            public PreservationSyringeSerum()
            {
                Color = new UnityEngine.Color(0.80000f, 0.6000f, 1.0000f);
            }
            public override void OnEnterLimb(LimbBehaviour limb)
            {
                if (limb.SpeciesIdentity == "Android")
                {
                    return;
                }
                limb.SkinMaterialHandler.ShouldRot = false;
                limb.CirculationBehaviour.StartCoroutine(this.RevertRotAndPreserve(limb));
            }
            public override void OnExitContainer(BloodContainer container) { }
            public override void OnUpdate(BloodContainer container) { }
            public override void OnEnterContainer(BloodContainer container) { }

            private IEnumerator RevertRotAndPreserve(LimbBehaviour limb)
            {
                while (limb.SkinMaterialHandler.RottenProgress > 0f)
                {
                    limb.SkinMaterialHandler.RottenProgress -= 0.2f * Time.deltaTime;
                    yield return new WaitForEndOfFrame();
                }
                while (true)
                {
                    if (limb.SkinMaterialHandler.RottenProgress > 0f)
                    { limb.SkinMaterialHandler.RottenProgress = 0f; }
                    yield return new WaitForEndOfFrame();
                }
            }
        }

    }
}

//Author: Polars Bear
