﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
    public class WeakSyringe : SyringeBehaviour
    {
        public const string name = "​<b></b>" + "Weakness Syringe";
        public static void Load()
        {
            ModAPI.RegisterLiquid(WeakSyringeSerum.ID, new WeakSyringeSerum());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

                    NameOverride = name,
                    DescriptionOverride = "Syringe that makes the user weak.",

                    CategoryOverride = ModAPI.FindCategory("Polars Bear"),
                    AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<WeakSyringe>(); }
                }
            );
            Mod.nailgun.SyringeNail(name, typeof(WeakSyringe));
        }
        public override string GetLiquidID() => WeakSyringeSerum.ID;
        public class WeakSyringeSerum : Liquid
        {
            public const string ID = "​<b></b>" + "WEAKNESS SERUM";
            public WeakSyringeSerum()
            {
                Color = new UnityEngine.Color(0.2f,0f,0.2f);
            }
            public override void OnEnterLimb(LimbBehaviour limb)
            {
                limb.BaseStrength *= 0.5f;
                limb.BreakingThreshold *= 0.75f;
                limb.InitialHealth *= 0.5f;
                limb.Health *= 0.5f;
            }
            public override void OnExitContainer(BloodContainer container) { }
            public override void OnUpdate(BloodContainer container) { }
            public override void OnEnterContainer(BloodContainer container) { }
        }

    }
}

//Author: Polars Bear
